﻿-- Author      : Nogarder
-- Create Date : 2013/6/8 13:31:51
local table_getn=table.getn
local table_insert=table.insert
local next=next
local UnitGUID=UnitGUID
local UnitExists=UnitExists
local string_find=string.find
local string_sub=string.sub
local tonumber=tonumber
local NPA_GetTime=NPA.GetTime
--
local NPA_NamePlateDataParser_AddElements=NPA.NamePlateDataParser.AddElements
local NPA_TextureManager_ManageTexture2=NPA.TextureManager.ManageTexture2
--
local UpdateOffset=function(modulemain,prioritylist,count)
	for i=1,count do
		if(prioritylist[i])then
			modulemain:ClearAllPoints()
			local anchor=prioritylist[i]
			modulemain:SetPoint(anchor.From,modulemain.Parent,anchor.To,anchor.OffsetX,anchor.OffsetY)
			return
		end
	end
end
--
NPA.NamePlateModuleManager.RegisterDataModule("MainFrame","Offset",function(framedata,modulemain,settings)
	local prioritylist={}
	--
	local TargetCondition={}
	local NameCondition={}
	local PartNameCondition={}
	local UnitIDCondition={}
	local SummonedCondition={}
	local PlayerCondition={}
	local NonPlayerCondition={}
	local WithAuraCondition={}
	local WithoutAuraCondition={}
	local HealthMoreCondition={}
	local HealthLessCondition={}
	local WithCoolDownCondition={}
	local WithoutCoolDownCondition={}
	local TappedCondition={}
	--
	local GuildCondition={}
	local NPCGuildCondition={}
	local PetCondition={}
	local GuardianCondition={}
	local FriendListCondition={}
	local GuildListCondition={}
	local PartyListCondition={}
	local RaidListCondition={}
	local RoleCondition={}
	local ClassificationCondition={}
	--
	local count=table_getn(settings)
	--add event elements
 	for i=1,count do
		local setting=settings[i]
		if(setting.ConditionType=="Default")then
			--using default alpha
			NPA_NamePlateDataParser_AddElements(framedata,"Offset","Offset_Updated",function(framedata,unitdata)
				prioritylist[i]={
					From="CENTER",
					To="CENTER",
					OffsetX=0,
					OffsetY=0,
				}
				UpdateOffset(modulemain,prioritylist,count)
			end)
		elseif(setting.ConditionType=="Any")then
			--any would always be using
			prioritylist[i]=setting.Offset
		elseif(setting.ConditionType=="Quest")then
			NPA_NamePlateDataParser_AddElements(framedata,"Offset","Quest_Updated",function(framedata,_,data)
				if(data)then
					prioritylist[i]=setting.Offset
				else
					prioritylist[i]=nil
				end
				UpdateOffset(modulemain,prioritylist,count)
			end)
		elseif(setting.ConditionType=="Name")then
			table_insert(NameCondition,i)
		elseif(setting.ConditionType=="PartName")then
			table_insert(PartNameCondition,i)
		elseif(setting.ConditionType=="UnitID")then
			table_insert(UnitIDCondition,i)
		elseif(setting.ConditionType=="Summoned")then
			table_insert(SummonedCondition,i)
		elseif(setting.ConditionType=="Player")then
			table_insert(PlayerCondition,i)
		elseif(setting.ConditionType=="NonPlayer")then
			table_insert(NonPlayerCondition,i)
		elseif(setting.ConditionType=="Target")then
			table_insert(TargetCondition,i)
		elseif(setting.ConditionType=="WithAura")then
			table_insert(WithAuraCondition,i)
		elseif(setting.ConditionType=="WithoutAura")then
			table_insert(WithoutAuraCondition,i)
		elseif(setting.ConditionType=="HealthMore")then
			table_insert(HealthMoreCondition,i)
		elseif(setting.ConditionType=="HealthLess")then
			table_insert(HealthLessCondition,i)
		elseif(setting.ConditionType=="WithCoolDown")then
			table_insert(WithCoolDown,i)
		elseif(setting.ConditionType=="WithoutCoolDown")then
			table_insert(WithoutCoolDown,i)
		elseif(setting.ConditionType=="Tapped")then
			table_insert(TappedCondition,i)
		--
		elseif(setting.ConditionType=="Guild")then
			table_insert(GuildCondition,i)
		elseif(setting.ConditionType=="NPCGuild")then
			table_insert(NPCGuildCondition,i)
		elseif(setting.ConditionType=="Pet")then
			table_insert(PetCondition,i)
		elseif(setting.ConditionType=="Guardian")then
			table_insert(GuardianCondition,i)
		elseif(setting.ConditionType=="FriendList")then
			table_insert(FriendListCondition,i)
		elseif(setting.ConditionType=="GuildList")then
			table_insert(GuildListCondition,i)
		elseif(setting.ConditionType=="PartyList")then
			table_insert(PartyListCondition,i)
		elseif(setting.ConditionType=="RaidList")then
			table_insert(RaidListCondition,i)
		elseif(setting.ConditionType=="Role")then
			table_insert(RoleCondition,i)
		elseif(setting.ConditionType=="Classification")then
			table_insert(ClassificationCondition,i)
		end
	end
	--default offset
	count=count+1
	prioritylist[count]={
		From="CENTER",
		To="CENTER",
		OffsetX=0,
		OffsetY=0,
	}
	--target
	if(next(TargetCondition))then
		NPA_NamePlateDataParser_AddElements(framedata,"Offset","ModuleMain_OnUpdate",function(framedata)
			local guid=framedata.GUID
			if(not guid)then
				return
			end
			--
			local update
			for i=1,table_getn(TargetCondition)do
				local index=TargetCondition[i]
				--check priority
				local setting=settings[index]
				local check=(UnitExists(setting.Arg) and guid==UnitGUID(setting.Arg))
				if(prioritylist[index]==nil and check)then
					prioritylist[index]=setting.Offset
					update=true
				elseif(prioritylist[index]~=nil and not check)then
					prioritylist[index]=nil
					update=true
				end
			end
			--
			if(update)then
				UpdateOffset(modulemain,prioritylist,count)
			end
		end)
	end
	--name
	if(next(NameCondition) or next(PartNameCondition))then
		NPA_NamePlateDataParser_AddElements(framedata,"Offset","Name_Updated",function(framedata,unitdata)
			local name=unitdata.Name
			if(not name)then
				--in case no name yet
				return
			end
			--
			local update
			--name check
			for i=1,table_getn(NameCondition)do
				local index=NameCondition[i]
				--check priority
				local setting=settings[index]
				if(prioritylist[index]==nil and name==setting.Arg)then
					prioritylist[index]=setting.Offset
					update=true
				elseif(prioritylist[index]~=nil and name~=setting.Arg)then
					prioritylist[index]=nil
					update=true
				end
			end
			--part name check
			for i=1,table_getn(PartNameCondition)do
				local index=PartNameCondition[i]
				--check priority
				local setting=settings[index]
				local found=string_find(name,setting.Arg)
				if(prioritylist[index]==nil and found)then
					prioritylist[index]=setting.Offset
					update=true
				elseif(prioritylist[index]~=nil and not found)then
					prioritylist[index]=nil
					update=true
				end
			end
			--
			if(update)then
				UpdateOffset(modulemain,prioritylist,count)
			end
		end)
	end
	--unitid
	if(next(UnitIDCondition))then
		NPA_NamePlateDataParser_AddElements(framedata,"Offset","UnitID_Updated",function(framedata)
			--this will get an unit id for npc
			local unitid=framedata.UnitData.UnitID
			local update
			--name check
			for i=1,table_getn(UnitIDCondition)do
				local index=UnitIDCondition[i]
				--check priority
				local setting=settings[index]
				if(prioritylist[index]==nil and unitid==setting.Arg)then
					prioritylist[index]=setting.Offset
					update=true
				elseif(prioritylist[index]~=nil and unitid~=setting.Arg)then
					prioritylist[index]=nil
					update=true
				end
			end
			--
			if(update)then
				UpdateOffset(modulemain,prioritylist,count)
			end
		end)
	end
	--summoned
	if(next(SummonedCondition))then
		NPA_NamePlateDataParser_AddElements(framedata,"Offset","Summoned_Updated",function(framedata,unitdata)
			--filter out sometime the sourceunitdata is not avaliable
			if(not unitdata.SummonedByUnitData)then
				return
			end
			--
			local update
			--check summoned
			local sourcefaction=unitdata.SummonedByUnitData.Faction
			for i=1,table_getn(SummonedCondition)do
				local index=SummonedCondition[i]
				--check priority
				local setting=settings[index]
				--faction, 1=friendly,2=neutral,3=hostile
				if(prioritylist[index]==nil and tonumber(setting.Arg)==sourcefaction)then
					prioritylist[index]=setting.Offset
					update=true
				elseif(prioritylist[index]~=nil and tonumber(setting.Arg)~=sourcefaction)then
					prioritylist[index]=nil
					update=true
				end
			end
			--
			if(update)then
				UpdateOffset(modulemain,prioritylist,count)
			end
		end)
	end
	--player
	if(next(PlayerCondition) or next(NonPlayerCondition) or next(FriendListCondition) or
		next(PetCondition) or next(GuardianCondition)
		or next(GuildListCondition) or next(PartyListCondition) or next(RaidListCondition))then
			NPA_NamePlateDataParser_AddElements(framedata,"Offset","Type_Updated",function(framedata,unitdata)
				--filter out sometime the sourceunitdata is not avaliable
				local update
				--check summoned
				local faction=framedata.UnitData.Faction
				local atype=framedata.UnitData.Type
				--data.Type= nil=unknow, 1=player,2=npc, 3=pet, 4=guardian
				if(atype==1)then --1=player
					for i=1,table_getn(PlayerCondition)do
						local index=PlayerCondition[i]
						--check priority
						local setting=settings[index]
						--faction, 1=friendly,2=neutral,3=hostile
						if(prioritylist[index]==nil and tonumber(setting.Arg)==faction)then
							prioritylist[index]=setting.Offset
							update=true
						elseif(prioritylist[index]~=nil and tonumber(setting.Arg)~=faction)then
							prioritylist[index]=nil
							update=true
						end
					end
				elseif(atype==3)then --3=pet
					for i=1,table_getn(PetCondition)do
						local index=PetCondition[i]
						--check priority
						local setting=settings[index]
						--faction, 1=friendly,2=neutral,3=hostile
						if(prioritylist[index]==nil and tonumber(setting.Arg)==faction)then
							prioritylist[index]=setting.Offset
							update=true
						elseif(prioritylist[index]~=nil and tonumber(setting.Arg)~=faction)then
							prioritylist[index]=nil
							update=true
						end
					end
				elseif(atype==4)then --4=guardian
					for i=1,table_getn(GuardianCondition)do
						local index=GuardianCondition[i]
						--check priority
						local setting=settings[index]
						--faction, 1=friendly,2=neutral,3=hostile
						if(prioritylist[index]==nil and tonumber(setting.Arg)==faction)then
							prioritylist[index]=setting.Offset
							update=true
						elseif(prioritylist[index]~=nil and tonumber(setting.Arg)~=faction)then
							prioritylist[index]=nil
							update=true
						end
					end
				else --other non-player
					for i=1,table_getn(NonPlayerCondition)do
						local index=NonPlayerCondition[i]
						--check priority
						local setting=settings[index]
						--faction, 1=friendly,2=neutral,3=hostile
						if(prioritylist[index]==nil and tonumber(setting.Arg)==faction)then
							prioritylist[index]=setting.Offset
							update=true
						elseif(prioritylist[index]~=nil and tonumber(setting.Arg)~=faction)then
							prioritylist[index]=nil
							update=true
						end
					end
				end
				--check friendlist
				--data.Type nil=unknow, 1=player,2=npc, 3=pet, 4=guardian
				--faction, 1=friendly,2=neutral,3=hostile
				if(faction==1 and atype==1)then
					local name=framedata.Name
					--friend list
					if(NPA.FriendsList.FriendList[name]==true)then --same faction and is player and in friendlist
						for i=1,table_getn(FriendListCondition)do
							local index=FriendListCondition[i]
							--check priority
							local setting=settings[index]
							if(prioritylist[index]==nil)then
								prioritylist[index]=setting.Offset
								update=true
							elseif(prioritylist[index]~=nil)then
								prioritylist[index]=nil
								update=true
							end
						end
					end
					--guildlist
					if(NPA.FriendsList.GuildList[name]==true)then --same faction and is player and in friendlist
						for i=1,table_getn(GuildListCondition)do
							local index=GuildListCondition[i]
							--check priority
							local setting=settings[index]
							if(prioritylist[index]==nil)then
								prioritylist[index]=setting.Offset
								update=true
							elseif(prioritylist[index]~=nil)then
								prioritylist[index]=nil
								update=true
							end
						end
					end
					--partylist
					if(NPA.FriendsList.PartyList[name]==true)then --same faction and is player and in friendlist
						for i=1,table_getn(PartyListCondition)do
							local index=PartyListCondition[i]
							--check priority
							local setting=settings[index]
							if(prioritylist[index]==nil)then
								prioritylist[index]=setting.Offset
								update=true
							elseif(prioritylist[index]~=nil)then
								prioritylist[index]=nil
								update=true
							end
						end
					end
					--raid list
					if(NPA.FriendsList.RaidList[name]==true)then --same faction and is player and in friendlist
						for i=1,table_getn(RaidListCondition)do
							local index=RaidListCondition[i]
							--check priority
							local setting=settings[index]
							if(prioritylist[index]==nil)then
								prioritylist[index]=setting.Offset
								update=true
							elseif(prioritylist[index]~=nil)then
								prioritylist[index]=nil
								update=true
							end
						end
					end
				end
				--
				if(update)then
					UpdateOffset(modulemain,prioritylist,count)
				end
			end)
		end
	--aura
	if(next(WithAuraCondition) or next(WithoutAuraCondition))then
		NPA_NamePlateDataParser_AddElements(framedata,"Offset","Aura_Updated",function(framedata,unitdata)
			if(not unitdata.Aura)then
				return
			end
			--
			local nTime=NPA_GetTime()
			--
			local update
			local auralist=framedata.UnitData.Aura
			--check with list
			for i=1,table_getn(WithAuraCondition)do
				local index=WithAuraCondition[i]
				local setting=settings[index]
				local checked
				for i=1,table_getn(auralist)do
					--check with list
					if(auralist[i].SpellId==tonumber(setting.Arg) and auralist[i].ExpirationTime>nTime)then
						checked=true
						break
					end
				end
				if(checked==true and prioritylist[index]==nil)then
					prioritylist[index]=setting.Offset
					update=true
				elseif(checked==nil and prioritylist[index]~=nil)then
					prioritylist[index]=nil
					update=true
				end
			end
			--check without list , just the revers version of with
			for i=1,table_getn(WithoutAuraCondition)do
				local index=WithoutAuraCondition[i]
				local setting=settings[index]
				local checked
				for i=1,table_getn(auralist)do
					--check with list
					if(auralist[i].SpellId==tonumber(setting.Arg) and auralist[i].ExpirationTime>nTime)then
						checked=true
						break
					end
				end
				if(checked==nil and prioritylist[index]==nil)then
					prioritylist[index]=setting.Offset
					update=true
				elseif(checked==true and prioritylist[index]~=nil)then
					prioritylist[index]=nil
					update=true
				end
			end
			--
			if(update)then
				UpdateOffset(modulemain,prioritylist,count)
			end
		end)
	end
	--health
	if(next(HealthMoreCondition) or next(HealthLessCondition))then
		NPA_NamePlateDataParser_AddElements(framedata,"Offset","Health_Updated",function(framedata,unitdata)
			if((not unitdata.Health) or (not unitdata.HealthMax))then
				return
			end
			local healthpercent=unitdata.Health/unitdata.HealthMax
			--check "more" condition
			for i=1,table_getn(HealthMoreCondition)do
				local index=HealthMoreCondition[i]
				local setting=settings[index]
				local checked
				--check with list
				if(healthpercent>=tonumber(setting.Arg)/100)then
					checked=true
				end
				if(checked==true and prioritylist[index]==nil)then
					prioritylist[index]=setting.Offset
					update=true
				elseif(checked==nil and prioritylist[index]~=nil)then
					prioritylist[index]=nil
					update=true
				end
			end
			--check "less" condition
			for i=1,table_getn(HealthLessCondition)do
				local index=HealthLessCondition[i]
				local setting=settings[index]
				local checked
				--check with list
				if(healthpercent<=tonumber(setting.Arg)/100)then
					checked=true
				end
				if(checked==true and prioritylist[index]==nil)then
					prioritylist[index]=setting.Offset
					update=true
				elseif(checked==nil and prioritylist[index]~=nil)then
					prioritylist[index]=nil
					update=true
				end
			end
			--
			if(update)then
				UpdateOffset(modulemain,prioritylist,count)
			end
		end)
	end
		--cooldown
	if(next(WithCoolDownCondition) or next(WithoutCoolDownCondition))then
		NPA_NamePlateDataParser_AddElements(framedata,"Offset","CoolDown_Updated",function(framedata,unitdata)
			if(not unitdata.CoolDown)then
				return
			end
			--
			local nTime=NPA_GetTime()
			--
			local update
			local auralist=framedata.UnitData.CoolDown
			--check with list
			for i=1,table_getn(WithCoolDownCondition)do
				local index=WithAuraCondition[i]
				local setting=settings[index]
				local checked
				local spellid=tonumber(setting.Arg)
				for i=1,table_getn(auralist)do
					--check with list
					if(auralist[i].SpellId==spellid and auralist[i].ExpirationTime>nTime)then
						checked=true
						break
					end
				end
				if(checked==true and prioritylist[index]==nil)then
					prioritylist[index]=setting.Offset
					update=true
				elseif(checked==nil and prioritylist[index]~=nil)then
					prioritylist[index]=nil
					update=true
				end
			end
			--check without list , just the revers version of with
			for i=1,table_getn(WithoutCoolDownCondition)do
				local index=WithoutAuraCondition[i]
				local setting=settings[index]
				local spellid=tonumber(setting.Arg)
				local checked
				for i=1,table_getn(auralist)do
					--check with list
					if(auralist[i].SpellId==spellid and auralist[i].ExpirationTime>nTime)then
						checked=true
						break
					end
				end
				if(checked==nil and prioritylist[index]==nil)then
					prioritylist[index]=setting.Offset
					update=true
				elseif(checked==true and prioritylist[index]~=nil)then
					prioritylist[index]=nil
					update=true
				end
			end
			--
			if(update)then
				UpdateOffset(modulemain,prioritylist,count)
			end
		end)
	end
	--tapped
	if(next(TappedCondition))then
		NPA_NamePlateDataParser_AddElements(framedata,"Offset","Tapped_Updated",function(framedata,unitdata)
			local tapped=unitdata.Tapped
			--
			local update
			--name check
			for i=1,table_getn(TappedCondition)do
				local index=TappedCondition[i]
				--check priority
				local setting=settings[index]
				if(prioritylist[index]==nil and tapped)then
					prioritylist[index]=setting.Offset
					update=true
				elseif(prioritylist[index]~=nil and not tapped)then
					prioritylist[index]=nil
					update=true
				end
			end
			--
			if(update)then
				UpdateOffset(modulemain,prioritylist,count)
			end
		end)
	end
	--guild
	if(next(GuildCondition))then
		NPA_NamePlateDataParser_AddElements(framedata,"Offset","Guild_Updated",function(framedata,unitdata)
			local guild=framedata.UnitData.Guild
			--
			local update
			--name check
			for i=1,table_getn(GuildCondition)do
				local index=GuildCondition[i]
				--check priority
				local setting=settings[index]
				if(prioritylist[index]==nil and guild==setting.Arg)then
					prioritylist[index]=setting.Offset
					update=true
				elseif(prioritylist[index]~=nil and guild~=setting.Arg)then
					prioritylist[index]=nil
					update=true
				end
			end
			--
			if(update)then
				UpdateAlpha(modulemain,prioritylist,count)
			end
		end)
	end
	--npcguild
	if(next(NPCGuildCondition))then
		NPA_NamePlateDataParser_AddElements(framedata,"Offset","NPCGuild_Updated",function(framedata,unitdata)
			local guild=framedata.UnitData.NPCGuild
			--
			local update
			--name check
			for i=1,table_getn(NPCGuildCondition)do
				local index=GuildCondition[i]
				--check priority
				local setting=settings[index]
				if(prioritylist[index]==nil and guild==setting.Arg)then
					prioritylist[index]=setting.Offset
					update=true
				elseif(prioritylist[index]~=nil and guild~=setting.Arg)then
					prioritylist[index]=nil
					update=true
				end
			end
			--
			if(update)then
				UpdateAlpha(modulemain,prioritylist,count)
			end
		end)
	end
	--role
	if(next(RoleCondition))then
		NPA_NamePlateDataParser_AddElements(framedata,"Offset","Role_Updated",function(framedata,unitdata)
			local role=unitdata.Role
			if(not role)then
				--in case no role yet
				return
			end
			--
			local update
			--name check
			for i=1,table_getn(RoleCondition)do
				local index=RoleCondition[i]
				--check priority
				local setting=settings[index]
				if(prioritylist[index]==nil and role==setting.Arg)then
					prioritylist[index]=setting.Offset
					update=true
				elseif(prioritylist[index]~=nil and role~=setting.Arg)then
					prioritylist[index]=nil
					update=true
				end
			end
			--
			if(update)then
				UpdateOffset(modulemain,prioritylist,count)
			end
		end)
	end
	--classification
	if(next(ClassificationCondition))then
		NPA_NamePlateDataParser_AddElements(framedata,"Offset","Classification_Updated",function(framedata,unitdata)
			local classification=unitdata.Classification
			if(not classification)then
				--in case no classification yet
				return
			end
			--
			local update
			--name check
			for i=1,table_getn(ClassificationCondition)do
				local index=ClassificationCondition[i]
				--check priority
				local setting=settings[index]
				if(prioritylist[index]==nil and classification==setting.Arg)then
					prioritylist[index]=setting.Offset
					update=true
				elseif(prioritylist[index]~=nil and classification~=setting.Arg)then
					prioritylist[index]=nil
					update=true
				end
			end
			--
			if(update)then
				UpdateOffset(modulemain,prioritylist,count)
			end
		end)
	end
	--update once
	UpdateOffset(modulemain,prioritylist,count)
end)
